#include <stdio.h>
#include <math.h>

#include "video_quality.h"

void
vq_psnr_init(vq_psnr_t *p)
{
    p->t = 0;
    p->n = 0;
}

void
vq_psnr_feed(vq_psnr_t *p, const unsigned char *d1,
    const unsigned char *d2, unsigned n)
{
    statistic_int_t t = 0;
    unsigned i;
    int dv;

    for(i = n; i > 0; i--) {
	dv = (int)*(d1++) - (int)*(d2++);
	t += dv * dv;
    }
    p->t += t;
    p->n += n;
}

void
vq_psnr_print(const vq_psnr_t *p, const char *t)
{
    double mse;

    mse = (double)p->t / p->n / (255 * 255);
    printf("psnr%s = %f\n", t, -10 * log10(mse));
    printf("mse%s = %.12f\n", t, mse);
}

void
vq_psnr_add(vq_psnr_t *a, unsigned ka, const vq_psnr_t *b, unsigned kb)
{
    a->t = ka * a->t + kb * b->t;
    a->n = ka * a->n + kb * b->n;
}
